diff -uwr sourceold/scripts/jfwzone.cpp source/scripts/jfwzone.cpp
--- sourceold/scripts/jfwzone.cpp	2011-12-01 12:21:47.211914000 +0800
+++ source/scripts/jfwzone.cpp	2012-02-23 12:11:58.802734300 +0800
@@ -22,6 +22,7 @@
 #include "VehicleGameObjDef.h"
 #include "BuildingGameObjDef.h"
 #include "dp88_custom_timer_defines.h"
+#include "PhysicalGameObj.h"
 
 void JFW_3D_Sound_Zone::Entered(GameObject *obj,GameObject *enterer)
 {
@@ -1186,6 +1187,7 @@
 		{
 			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
 		}
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
@@ -1909,6 +1911,7 @@
 		{
 			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
 		}
+		obj->As_PhysicalGameObj()->Clear_Animation();
 		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
@@ -2098,6 +2101,29 @@
 	}
 }
 
+void JFW_Radar_Spy_Zone_New::Created(GameObject *obj)
+{
+	reset = false;
+}
+
+void JFW_Radar_Spy_Zone_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (Get_Vehicle(enterer) || reset)
+	{
+		return;
+	}
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	if ((Is_Building_Dead(Find_Com_Center(Commands->Get_Player_Type(enterer))) && (Is_Radar_Enabled(PTTEAM(Commands->Get_Player_Type(enterer))))))
+	{
+		Create_2D_Sound_Team(Get_Parameter("Sound"),Commands->Get_Player_Type(enterer));
+		Enable_Base_Radar(Get_Object_Type(enterer),true);
+		reset = true;
+	}
+}
+
 void JFW_2D_Sound_Zone_Team::Entered(GameObject *obj,GameObject *enterer)
 {
 	int team;
@@ -2509,8 +2535,9 @@
 			Commands->Give_Money(Get_Vehicle_Driver(Commands->Find_Object(ID)),cost,false);
 			Commands->Send_Custom_Event(Owner(),Commands->Find_Object(ID),CUSTOM_ENTERED_VTOL_LAND_ZONE,0,0);
 			Force_Occupants_Exit(Commands->Find_Object(ID));
-			Commands->Start_Timer(Owner(),this,1,1);
+			Commands->Start_Timer(Owner(),this,1,ID);
 			RemoveHook();
+			ID = 0;
 		}
 	}
 }
@@ -2527,8 +2554,7 @@
 
 void JFW_Sell_Zone::Timer_Expired(GameObject *obj,int number)
 {
-	Commands->Destroy_Object(Commands->Find_Object(ID));
-	ID = 0;
+	Commands->Destroy_Object(Commands->Find_Object(number));
 }
 
 void JFW_Infantry_Force_Composition_Zone::Created(GameObject *obj)
@@ -2763,6 +2789,238 @@
 	SAFE_DELETE_ARRAY(IDs);
 }
 
+void JFW_Infantry_Force_Composition_Zone_New::Created(GameObject *obj)
+{
+	reset = false;
+	count = 0;
+	TeamPurchaseSettingsDefClass *teamdefs[2];
+	teamdefs[0] = TeamPurchaseSettingsDefClass::Get_Definition(TeamPurchaseSettingsDefClass::TEAM_GDI);
+	teamdefs[1] = TeamPurchaseSettingsDefClass::Get_Definition(TeamPurchaseSettingsDefClass::TEAM_NOD);
+	PurchaseSettingsDefClass *defs[4];
+	defs[0] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_CLASSES,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[1] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_CLASSES,PurchaseSettingsDefClass::TEAM_NOD);
+	defs[2] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_CLASSES,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[3] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_CLASSES,PurchaseSettingsDefClass::TEAM_NOD);
+	for (unsigned int d = 0;d < 2;d++)
+	{
+		for (unsigned int i = 0;i < 4;i++)
+		{
+			if (teamdefs[d]->Get_Enlisted_Definition(i))
+			{
+				count++;
+			}
+		}
+	}
+	for (unsigned int d = 0;d < 4;d++)
+	{
+		for (unsigned int i = 0;i < 10;i++)
+		{
+			if ((defs[d]) && (defs[d]->Get_Definition(i)))
+			{
+				count++;
+				if (defs[d]->Get_Alt_Definition(i,0))
+				{
+					count++;
+					if (defs[d]->Get_Alt_Definition(i,1))
+					{
+						count++;
+						if (defs[d]->Get_Alt_Definition(i,2))
+						{
+							count++;
+						}
+					}
+				}
+			}
+		}
+	}
+	IDs = new unsigned int[count];
+	int pos = 0;
+	for (unsigned int d = 0;d < 2;d++)
+	{
+		for (unsigned int i = 0;i < 4;i++)
+		{
+			if (teamdefs[d]->Get_Enlisted_Definition(i))
+			{
+				IDs[pos] = teamdefs[d]->Get_Enlisted_Definition(i);
+				pos++;
+			}
+		}
+	}
+	for (unsigned int d = 0;d < 4;d++)
+	{
+		for (unsigned int i = 0;i < 10;i++)
+		{
+			if ((defs[d]) && (defs[d]->Get_Definition(i)))
+			{
+				IDs[pos] = defs[d]->Get_Definition(i);
+				pos++;
+				if (defs[d]->Get_Alt_Definition(i,0))
+				{
+					IDs[pos] = defs[d]->Get_Alt_Definition(i,0);
+					pos++;
+					if (defs[d]->Get_Alt_Definition(i,1))
+					{
+						IDs[pos] = defs[d]->Get_Alt_Definition(i,1);
+						pos++;
+						if (defs[d]->Get_Alt_Definition(i,2))
+						{
+							IDs[pos] = defs[d]->Get_Alt_Definition(i,2);
+							pos++;
+						}
+					}
+				}
+			}
+		}
+	}
+}
+
+void JFW_Infantry_Force_Composition_Zone_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (Get_Vehicle(enterer) || reset)
+	{
+		return;
+	}
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	int Player_Type = Commands->Get_Player_Type(enterer);
+	int Count_Player_Type = PTTEAM(Player_Type);
+	Create_2D_Sound_Team(Get_Parameter("Sound"),Player_Type);
+	Send_Message_Team(Player_Type,255,255,255,"Current Enemy Infantry Strength:\n");
+	reset = true;
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("ResetTime"),1);
+	for (unsigned int i = 0;i < count;i++)
+	{
+		const char *name = Get_Definition_Name(IDs[i]);
+		unsigned int count = Get_Object_Count(Count_Player_Type,name);
+		if (count)
+		{
+			char str[100];
+			const char *str2 = Get_Translated_Definition_Name(name);
+			sprintf(str,"%s: %d\n",str2,count);
+			delete[] str2;
+			Send_Message_Team(Player_Type,255,255,255,str);
+		}
+	}
+}
+
+void JFW_Infantry_Force_Composition_Zone_New::Timer_Expired(GameObject *obj,int number)
+{
+	reset = false;
+}
+
+JFW_Infantry_Force_Composition_Zone_New::~JFW_Infantry_Force_Composition_Zone_New()
+{
+	SAFE_DELETE_ARRAY(IDs);
+}
+
+void JFW_Vehicle_Force_Composition_Zone_New::Created(GameObject *obj)
+{
+	reset = false;
+	count = 0;
+	PurchaseSettingsDefClass *defs[8];
+	defs[0] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[1] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_VEHICLES,PurchaseSettingsDefClass::TEAM_NOD);
+	defs[2] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[3] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES,PurchaseSettingsDefClass::TEAM_NOD);
+	defs[4] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[5] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,PurchaseSettingsDefClass::TEAM_NOD);
+	defs[6] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_AIR,PurchaseSettingsDefClass::TEAM_GDI);
+	defs[7] = PurchaseSettingsDefClass::Find_Definition(PurchaseSettingsDefClass::TYPE_NAVAL,PurchaseSettingsDefClass::TEAM_NOD);
+	for (unsigned int d = 0;d < 7;d++)
+	{
+		for (unsigned int i = 0;i < 10;i++)
+		{
+			if ((defs[d]) && (defs[d]->Get_Definition(i)))
+			{
+				count++;
+				if (defs[d]->Get_Alt_Definition(i,0))
+				{
+					count++;
+					if (defs[d]->Get_Alt_Definition(i,1))
+					{
+						count++;
+						if (defs[d]->Get_Alt_Definition(i,2))
+						{
+							count++;
+						}
+					}
+				}
+			}
+		}
+	}
+	IDs = new unsigned int[count];
+	int pos = 0;
+	for (unsigned int d = 0;d < 7;d++)
+	{
+		for (unsigned int i = 0;i < 10;i++)
+		{
+			if ((defs[d]) && (defs[d]->Get_Definition(i)))
+			{
+				IDs[pos] = defs[d]->Get_Definition(i);
+				pos++;
+				if (defs[d]->Get_Alt_Definition(i,0))
+				{
+					IDs[pos] = defs[d]->Get_Alt_Definition(i,0);
+					pos++;
+					if (defs[d]->Get_Alt_Definition(i,1))
+					{
+						IDs[pos] = defs[d]->Get_Alt_Definition(i,1);
+						pos++;
+						if (defs[d]->Get_Alt_Definition(i,2))
+						{
+							IDs[pos] = defs[d]->Get_Alt_Definition(i,2);
+							pos++;
+						}
+					}
+				}
+			}
+		}
+	}
+}
+
+void JFW_Vehicle_Force_Composition_Zone_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (Get_Vehicle(enterer) || reset)
+	{
+		return;
+	}
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	int Player_Type = Commands->Get_Player_Type(enterer);
+	int Count_Player_Type = PTTEAM(Player_Type);
+	Create_2D_Sound_Team(Get_Parameter("Sound"),Player_Type);
+	Send_Message_Team(Player_Type,255,255,255,"Current Enemy Vehicle Strength:\n");
+	reset = true;
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("ResetTime"),1);
+	for (unsigned int i = 0;i < count;i++)
+	{
+		const char *name = Get_Definition_Name(IDs[i]);
+		unsigned int count = Get_Object_Count(Count_Player_Type,name);
+		if (count)
+		{
+			char str[100];
+			const char *str2 = Get_Translated_Definition_Name(name);
+			sprintf(str,"%s: %d\n",str2,count);
+			delete[] str2;
+			Send_Message_Team(Player_Type,255,255,255,str);
+		}
+	}
+}
+
+void JFW_Vehicle_Force_Composition_Zone_New::Timer_Expired(GameObject *obj,int number)
+{
+	reset = false;
+}
+
+JFW_Vehicle_Force_Composition_Zone_New::~JFW_Vehicle_Force_Composition_Zone_New()
+{
+	SAFE_DELETE_ARRAY(IDs);
+}
+
 void JFW_Resize_Zone::Created(GameObject *obj)
 {
 	ScriptZoneGameObj *object = ((ScriptableGameObj *)obj)->As_ScriptZoneGameObj();
@@ -2785,6 +3043,7 @@
 		object->Get_Bounding_Box().Basis[2].Y = 0;
 		object->Get_Bounding_Box().Basis[2].Z = 1;
 	}
+	Destroy_Script();
 }
 
 void JFW_Custom_Spawn_Zone::Created(GameObject *obj)
@@ -2910,6 +3169,80 @@
 	}
 }
 
+void JFW_Cash_Spy_Zone_New::Created(GameObject *obj)
+{
+	reset = false;
+}
+
+void JFW_Cash_Spy_Zone_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (Get_Vehicle(enterer) || reset)
+	{
+		return;
+	}
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	int team = Commands->Get_Player_Type(enterer);
+	char str[100];
+	reset = true;
+	Commands->Start_Timer(obj,this,Get_Float_Parameter("ResetTime"),1);
+	Create_2D_Sound_Team(Get_Parameter("Sound"),team);
+	sprintf(str,"Current Enemy Credits: %.0f\n",Get_Team_Credits(PTTEAM(team)));
+	Send_Message_Team(team,255,255,255,str);
+}
+
+void JFW_Cash_Spy_Zone_New::Timer_Expired(GameObject *obj,int number)
+{
+	reset = false;
+}
+
+void JFW_Power_Spy_Zone_New::Created(GameObject *obj)
+{
+	reset = false;
+}
+
+void JFW_Power_Spy_Zone_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	team = Commands->Get_Player_Type(enterer);
+	if (Is_Base_Powered(PTTEAM(team)) && !reset && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	{
+		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
+		Power_Base(PTTEAM(team),false);
+		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		if (o && !Is_Building_Dead(o))
+		{
+			Enable_Base_Radar(PTTEAM(team),false);
+		}
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("Power_Time"),1);
+	}
+}
+
+void JFW_Power_Spy_Zone_New::Timer_Expired(GameObject *obj,int number)
+{
+	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_POWER_PLANT))))
+	{
+		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
+		Power_Base(PTTEAM(team),true);
+		GameObject *o = Find_Building(PTTEAM(team),BuildingConstants::TYPE_COM_CENTER);
+		if (o && !Is_Building_Dead(o))
+		{
+			Enable_Base_Radar(PTTEAM(team),true);
+		}
+		reset = true;
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("Reset_Time"),2);
+	}
+	if (number == 2)
+	{
+		reset = false;
+	}
+}
+
 void JFW_Conyard_Spy_Zone::Created(GameObject *obj)
 {
 	reset = false;
@@ -2988,6 +3321,46 @@
 	}
 }
 
+void JFW_Conyard_Spy_Zone_2_New::Created(GameObject *obj)
+{
+	reset = false;
+	cydisabled = false;
+}
+
+void JFW_Conyard_Spy_Zone_2_New::Entered(GameObject *obj,GameObject *enterer)
+{
+	if (!Is_Spy(enterer))
+	{
+		return;
+	}
+	int team = Commands->Get_Player_Type(enterer);
+	if (!cydisabled && !reset && (!Is_Building_Dead(Find_Construction_Yard(PTTEAM(team)))))
+	{
+		Create_2D_Sound_Team(Get_Parameter("Sound"),team);
+		cydisabled = true;
+		ConstructionYardGameObj *obj2 = (ConstructionYardGameObj *)Find_Construction_Yard(PTTEAM(team));
+		obj2->Set_Spy(true);
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("Power_Time"),1);
+	}
+}
+
+void JFW_Conyard_Spy_Zone_2_New::Timer_Expired(GameObject *obj,int number)
+{
+	if ((number == 1) && (!Is_Building_Dead(Find_Building(PTTEAM(team),BuildingConstants::TYPE_CONYARD))))
+	{
+		Create_2D_Sound_Team(Get_Parameter("Sound2"),PTTEAM(team));
+		cydisabled = false;
+		ConstructionYardGameObj *obj2 = (ConstructionYardGameObj *)Find_Construction_Yard(PTTEAM(team));
+		obj2->Set_Spy(false);
+		reset = true;
+		Commands->Start_Timer(obj,this,Get_Float_Parameter("Reset_Time"),2);
+	}
+	if (number == 2)
+	{
+		reset = false;
+	}
+}
+
 ScriptRegistrant<JFW_Look_At_Location_Entry> JFW_Look_At_Location_Entry("JFW_Look_At_Location_Entry","Player_Type:int,Location:vector3");
 ScriptRegistrant<JFW_Look_At_Object_Entry> JFW_Look_At_Object_Entry("JFW_Look_At_Object_Entry","Player_Type:int,ObjectID:int");
 ScriptRegistrant<JFW_Zone_PCT> JFW_Zone_PCT_Registrant("JFW_Zone_PCT","Player_Type:int");
@@ -3057,19 +3430,25 @@
 ScriptRegistrant<JFW_Send_Driver_Custom_On_Enter> JFW_Send_Driver_Custom_On_Enter("JFW_Send_Driver_Custom_On_Enter","EnterMessage:int,ExitMessage:int");
 ScriptRegistrant<JFW_Teleport_Zone_Enable> JFW_Teleport_Zone_Enable_Registrant("JFW_Teleport_Zone_Enable","Location:vector3,Object_ID=0:int,Player_Type:int,EnableCustom:int,DisableCustom:int");
 ScriptRegistrant<JFW_Radar_Spy_Zone> JFW_Radar_Spy_Zone_Registrant("JFW_Radar_Spy_Zone","Spy_Script:string,Sound:string");
+ScriptRegistrant<JFW_Radar_Spy_Zone_New> JFW_Radar_Spy_Zone_New_Registrant("JFW_Radar_Spy_Zone_New","Sound:string");
 ScriptRegistrant<JFW_2D_Sound_Zone_Team> JFW_2D_Sound_Zone_Team_Registrant("JFW_2D_Sound_Zone_Team","Player_Type:int,Sound:string,Time:float,TimerNum:int,Sound_Player_Type:int");
 ScriptRegistrant<JFW_Repair_Zone_2> JFW_Repair_Zone_2_Registrant("JFW_Repair_Zone_2","Player_Type:int,Repair_Distance:float,Repair_Health:float,Sound:string,Credits:float,RepairSound:string,RepairStopSound:string");
 ScriptRegistrant<JFW_Repair_Zone_No_Boats> JFW_Repair_Zone_No_Boats_Registrant("JFW_Repair_Zone_No_Boats","Player_Type:int,Repair_Distance:float,Repair_Health:float,Sound:string,Credits:float,RepairSound:string,RepairStopSound:string");
 ScriptRegistrant<JFW_Repair_Zone_Boats> JFW_Repair_Zone_Boats_Registrant("JFW_Repair_Zone_Boats","Player_Type:int,Repair_Distance:float,Repair_Health:float,Sound:string,Credits:float,RepairSound:string,RepairStopSound:string");
 ScriptRegistrant<JFW_Infantry_Force_Composition_Zone> JFW_Infantry_Force_Composition_Zone_Registrant("JFW_Infantry_Force_Composition_Zone","Spy_Script:string,Sound:string,ResetTime:float");
 ScriptRegistrant<JFW_Vehicle_Force_Composition_Zone> JFW_Vehicle_Force_Composition_Zone_Registrant("JFW_Vehicle_Force_Composition_Zone","Spy_Script:string,Sound:string,ResetTime:float");
+ScriptRegistrant<JFW_Infantry_Force_Composition_Zone_New> JFW_Infantry_Force_Composition_Zone_New_Registrant("JFW_Infantry_Force_Composition_Zone_New","Sound:string,ResetTime:float");
+ScriptRegistrant<JFW_Vehicle_Force_Composition_Zone_New> JFW_Vehicle_Force_Composition_Zone_New_Registrant("JFW_Vehicle_Force_Composition_Zone_New","Sound:string,ResetTime:float");
 ScriptRegistrant<JFW_Sell_Zone> JFW_Sell_Zone_Registrant("JFW_Sell_Zone","Player_Type:int,Sound:string,SellSound:string");
 ScriptRegistrant<JFW_Resize_Zone> JFW_Resize_Zone_Registrant("JFW_Resize_Zone","Size:vector3,ZRotate:float");
 ScriptRegistrant<JFW_Cash_Spy_Zone> JFW_Cash_Spy_Zone_Registrant("JFW_Cash_Spy_Zone","Spy_Script:string,Sound:string,ResetTime:float");
 ScriptRegistrant<JFW_Power_Spy_Zone> JFW_Power_Spy_Zone_Registrant("JFW_Power_Spy_Zone","Spy_Script:string,Power_Time:float,Reset_Time:float,Sound:string,Sound2:string");
+ScriptRegistrant<JFW_Cash_Spy_Zone_New> JFW_Cash_Spy_Zone_New_Registrant("JFW_Cash_Spy_Zone_New","Sound:string,ResetTime:float");
+ScriptRegistrant<JFW_Power_Spy_Zone_New> JFW_Power_Spy_Zone_New_Registrant("JFW_Power_Spy_Zone_New","Power_Time:float,Reset_Time:float,Sound:string,Sound2:string");
 ScriptRegistrant<JFW_Blow_Up_On_Enter_Delay> JFW_Blow_Up_On_Enter_Delay_Registrant("JFW_Blow_Up_On_Enter_Delay","Player_Type:int,Time:float,TimerNum:int,Explosion:string");
 ScriptRegistrant<JFW_Conyard_Spy_Zone> JFW_Conyard_Spy_Zone_Registrant("JFW_Conyard_Spy_Zone","Spy_Script:string,Power_Time:float,Reset_Time:float,Sound:string,Sound2:string");
 ScriptRegistrant<JFW_Conyard_Spy_Zone_2> JFW_Conyard_Spy_Zone_2_Registrant("JFW_Conyard_Spy_Zone_2","Spy_Script:string,Power_Time:float,Reset_Time:float,Sound:string,Sound2:string");
+ScriptRegistrant<JFW_Conyard_Spy_Zone_2_New> JFW_Conyard_Spy_Zone_2_New_Registrant("JFW_Conyard_Spy_Zone_2_New","Power_Time:float,Reset_Time:float,Sound:string,Sound2:string");
 ScriptRegistrant<JFW_Custom_Spawn_Zone> JFW_Custom_Spawn_Zone_Registrant("JFW_Custom_Spawn_Zone","Position:vector3,Size:vector3,ZRotate:float,SpawnCustom:int,DestroyCustom:int,Preset:string");
 ScriptRegistrant<JFW_Spawn_Zone_Created> JFW_Spawn_Zone_Created_Registrant("JFW_Spawn_Zone_Created","Offset:vector3,Size:vector3,ZRotate:float,Preset:string");
 ScriptRegistrant<JFW_Boat> JFW_Boat_Registrant("JFW_Boat","");
diff -uwr sourceold/scripts/jfwzone.h source/scripts/jfwzone.h
--- sourceold/scripts/jfwzone.h	2011-10-23 10:40:52.437500200 +0800
+++ source/scripts/jfwzone.h	2012-02-13 18:44:52.651765600 +0800
@@ -368,6 +368,12 @@
 	void Entered(GameObject *obj,GameObject *enterer);
 };
 
+class JFW_Radar_Spy_Zone_New : public ScriptImpClass {
+	bool reset;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+};
+
 class JFW_2D_Sound_Zone_Team : public ScriptImpClass {
 	void Entered(GameObject *obj,GameObject *enterer);
 	void Timer_Expired(GameObject *obj,int number);
@@ -437,6 +443,30 @@
 	~JFW_Vehicle_Force_Composition_Zone();
 };
 
+class JFW_Infantry_Force_Composition_Zone_New : public ScriptImpClass {
+	unsigned int *IDs;
+	unsigned int count;
+	bool reset;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+	void Timer_Expired(GameObject *obj,int number);
+public:
+	JFW_Infantry_Force_Composition_Zone_New() {IDs = 0;}
+	~JFW_Infantry_Force_Composition_Zone_New();
+};
+
+class JFW_Vehicle_Force_Composition_Zone_New : public ScriptImpClass {
+	unsigned int *IDs;
+	unsigned int count;
+	bool reset;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+	void Timer_Expired(GameObject *obj,int number);
+public:
+	JFW_Vehicle_Force_Composition_Zone_New() {IDs = 0;}
+	~JFW_Vehicle_Force_Composition_Zone_New();
+};
+
 class JFW_Resize_Zone : public ScriptImpClass {
 	void Created(GameObject *obj);
 };
@@ -456,6 +486,21 @@
 	void Timer_Expired(GameObject *obj,int number);
 };
 
+class JFW_Cash_Spy_Zone_New : public ScriptImpClass {
+	bool reset;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class JFW_Power_Spy_Zone_New : public ScriptImpClass {
+	bool reset;
+	int team;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
 class JFW_Conyard_Spy_Zone : public ScriptImpClass {
 	bool reset;
 	bool cydisabled;
@@ -469,6 +514,15 @@
 	bool reset;
 	bool cydisabled;
 	int team;
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj,GameObject *enterer);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+class JFW_Conyard_Spy_Zone_2_New : public ScriptImpClass {
+	bool reset;
+	bool cydisabled;
+	int team;
 	void Created(GameObject *obj);
 	void Entered(GameObject *obj,GameObject *enterer);
 	void Timer_Expired(GameObject *obj,int number);
diff -uwr sourceold/scripts/mdb.cpp source/scripts/mdb.cpp
--- sourceold/scripts/mdb.cpp	2011-10-11 23:05:49.406250000 +0800
+++ source/scripts/mdb.cpp	2012-02-13 19:12:33.842195300 +0800
@@ -159,6 +159,7 @@
 	char Limit[20];
 	sprintf(Limit,"vlimit %d",Get_Int_Parameter("Limit"));
 	Console_Input(Limit);
+	Destroy_Script();
 }
 
 void MDB_Mine_Limit::Created(GameObject *obj)
@@ -168,6 +169,7 @@
 	if (Num > 127) Num = 127;
 	sprintf(Limit,"mlimit %d",Num);
 	Console_Input(Limit);
+	Destroy_Script();
 }
 
 void MDB_Unit_Limit::Created(GameObject *obj)
diff -uwr sourceold/scripts/ra2.cpp source/scripts/ra2.cpp
--- sourceold/scripts/ra2.cpp	2011-10-11 23:06:35.896484300 +0800
+++ source/scripts/ra2.cpp	2012-02-13 19:12:33.791414000 +0800
@@ -359,6 +359,7 @@
 		tree = Commands->Create_Object(preset,TreePos);
 		Commands->Attach_To_Object_Bone(tree,obj,"origin");
 	}
+	Destroy_Script();
 }
 
 void Ra2Ven_TurretSound::Created(GameObject *obj)
diff -uwr sourceold/scripts/reborn.cpp source/scripts/reborn.cpp
--- sourceold/scripts/reborn.cpp	2011-10-11 23:06:34.511718700 +0800
+++ source/scripts/reborn.cpp	2012-02-13 19:12:33.738679700 +0800
@@ -289,6 +289,7 @@
 void Reborn_PlaySound_OnCreate::Created(GameObject *obj)
 {
 	Commands->Create_2D_Sound(Get_Parameter("Sound_Preset_Name"));
+	Destroy_Script();
 }
 
 //Reborn Diggable Vehicle Animated
diff -uwr sourceold/scripts/renalert.cpp source/scripts/renalert.cpp
--- sourceold/scripts/renalert.cpp	2011-10-21 21:50:39.677734300 +0800
+++ source/scripts/renalert.cpp	2012-02-13 19:12:33.152742200 +0800
@@ -21,6 +21,8 @@
 #include "SmartGameObj.h"
 #include "VehicleGameObjDef.h"
 #include "ArmorWarheadManager.h"
+#include "SoldierGameObjDef.h"
+#include "SoldierGameObj.h"
 #ifdef SSGM
 #include "gmlog.h"
 #endif
@@ -396,6 +398,7 @@
 	c = Get_Parameter("Object");
 	v = Commands->Get_Position(obj);
 	Commands->Apply_Damage(Commands->Create_Object(c,v),100,war,0);
+	Destroy_Script();
 }
 
 //////////////RA_Naval_Yard//////////////
@@ -702,6 +705,7 @@
 	GameObject *BoomBox;
 	BoomBox = Commands->Create_Object(Get_Parameter("Preset"),Commands->Get_Position(obj));
 	Commands->Apply_Damage(BoomBox, 100, "BlamoKiller", 0);
+	Destroy_Script();
 }
 
 //////////////RA_Demolition_Truck_Improved//////////////
@@ -956,7 +960,7 @@
 			if (driverID == testID)
 			{
 				//Create Object to jam MAD Tank in place
-				GameObject *newobj = Commands->Create_Object_At_Bone(obj, "Generic_Cinematic", Get_Parameter("Bone"));
+				GameObject *newobj = Commands->Create_Object_At_Bone(obj, "Invisible_Object", Get_Parameter("Bone"));
 				Commands->Set_Model(newobj, Get_Parameter("Attach_Model"));
 				Commands->Attach_To_Object_Bone(newobj, obj, Get_Parameter("Bone"));
 				newobjID = Commands->Get_ID(newobj);
@@ -3263,7 +3267,7 @@
 				Commands->Destroy_Object(Commands->Find_Object(modelID));
 			}
 			Vector3 position = Commands->Get_Bone_Position(obj,Get_Parameter("BoneName"));
-			GameObject *object = Commands->Create_Object("Generic_Cinematic", position);
+			GameObject *object = Commands->Create_Object("Invisible_Object", position);
 			Commands->Attach_To_Object_Bone(object, obj, Get_Parameter("BoneName"));
 			Commands->Send_Custom_Event(obj, sender, Get_Int_Parameter("Message"), Commands->Get_ID(object), 0);
 			modelID = Commands->Get_ID(object);
@@ -3303,7 +3307,7 @@
 				if (!modelID)
 				{
 					Vector3 position = Commands->Get_Bone_Position(obj, Get_Parameter("BoneName"));
-					GameObject *object = Commands->Create_Object("Generic_Cinematic", position);
+					GameObject *object = Commands->Create_Object("Invisible_Object", position);
 					Commands->Attach_To_Object_Bone(object, obj, Get_Parameter("BoneName"));
 					Commands->Send_Custom_Event(obj, Commands->Find_Object(driverID), Get_Int_Parameter("Message"), Commands->Get_ID(object), 0);
 					modelID = Commands->Get_ID(object);
@@ -3432,6 +3436,106 @@
 	Auto_Save_Variable(&blackout,4,4);
 }
 
+//////////////RA_Vision_Control_2//////////////
+
+void RA_Vision_Control_2::Created(GameObject *obj)
+{
+	allowed = true; 
+	underwater = false;
+	driving = false;
+	blackout = false;
+	//Revert the screen incase player died while underwater
+	Set_Screen_Fade_Color_Player(obj, 0, 0, 0, 0); //revert color
+	Set_Screen_Fade_Opacity_Player(obj,0, 0); //revert opacity
+	Set_Fog_Color_Player(obj, 256, 256, 256);
+	Clear_Fog_Override_Player(obj);
+}
+
+void RA_Vision_Control_2::Custom(GameObject *obj, int type, int param, GameObject *sender)
+{
+	switch(type)
+	{
+	case 852852: //Disabling type, will cause 'underwater' messages to be ignored
+		allowed = false;
+		break;
+	case 258258: //Enabling type, will allow 'underwater' messages
+		allowed = true;
+		break;
+	case 789789: //Diving type, will activate underwater effect (overrides other effects)
+		if (allowed)
+		{
+			if (!driving) //oops, did I go overboard?
+			{
+				Commands->Apply_Damage(obj, 100, "Death", 0); //I drowned
+			}
+			if (blackout)//if blackout in effect, deactivate
+			{	
+				Set_Fog_Color_Player(obj, 256, 256, 256);
+				Clear_Fog_Override_Player(obj);
+				blackout = false;
+			}
+			Set_Screen_Fade_Color_Player(obj, 0, 0, 1, 0);
+			Set_Screen_Fade_Opacity_Player(obj, 150, 0);
+			underwater = true;
+		}
+		break;
+	case 987987: //Surfacing type, will deactivate underwater effect
+		Set_Screen_Fade_Color_Player(obj, 0, 0, 0, 0);
+		Set_Screen_Fade_Opacity_Player(obj, 0, 0);
+		underwater = false;
+		break;
+	case 325523: //Blackout type, param 0 = blackout off, param 1 = blackout on
+		if (!underwater) //Underwater takes priority
+		{
+			if (param == 1) //turn on effect
+			{
+				if (!blackout)
+				{
+					Set_Screen_Fade_Color_Player(obj, 0, 0, 0, 0);
+					Set_Screen_Fade_Opacity_Player(obj, 150, 0);
+					if (Get_Vehicle(obj))
+					{
+						Set_Fog_Override_Player(obj, Get_Float_Parameter("VehicleFogStart"), Get_Float_Parameter("VehicleFogEnd"));
+					}
+					else
+					{
+						Set_Fog_Override_Player(obj, Get_Float_Parameter("InfantryFogStart"), Get_Float_Parameter("InfantryFogEnd"));
+					}
+					Set_Fog_Color_Player(obj, 0, 0, 0);
+					blackout = true;
+				}
+			}
+			else if (!param) //turn off effect
+			{
+				if (blackout)
+				{
+					Set_Screen_Fade_Color_Player(obj, 0, 0, 0, 0);
+					Set_Screen_Fade_Opacity_Player(obj, 0, 0);
+					Clear_Fog_Override_Player(obj);
+					blackout = false;
+				}
+			}
+		}
+		break;
+	case 310013: //Exited Vehicle Message
+		driving = false;
+		if (underwater)
+			Commands->Apply_Damage(obj, 100, "Death", 0);
+		break;
+	case 103301: //Entered Vehicle Message
+		driving = true;
+		break;
+	}
+}
+
+void RA_Vision_Control_2::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&allowed,4,1);
+	Auto_Save_Variable(&underwater,4,2);
+	Auto_Save_Variable(&driving,4,3);
+	Auto_Save_Variable(&blackout,4,4);
+}
+
 //////////////RA_Fog_Level_Settings//////////////
 
 void RA_Fog_Level_Settings::Custom(GameObject *obj, int type, int param, GameObject *sender)
@@ -3444,6 +3548,7 @@
 {
 	GameObject *silo = Find_Object_By_Preset(2, Get_Parameter("SiloPresetName"));
 	Commands->Send_Custom_Event(obj, silo, 269269, 0, 0.0);
+	Destroy_Script();
 }
 
 //////////////RA_Beacon_Terminal//////////////
@@ -3487,7 +3592,7 @@
 			Create_2D_Sound_Team(Get_Parameter("BeaconTakenSound"), Commands->Get_Player_Type(obj));
 		}
 	}
-	else if(Is_Script_Attached(poker, "RA_Infantry_Spy"))
+	else if (Is_Spy(poker))
 	{
 		if(!reset)
 		{
@@ -3764,7 +3869,7 @@
 	if (!ownerID)
 	{
 		//Create Object to jam MAD Tank in place
-		GameObject *newobj = Commands->Create_Object_At_Bone(obj, "Generic_Cinematic", Get_Parameter("Bone"));
+		GameObject *newobj = Commands->Create_Object_At_Bone(obj, "Invisible_Object", Get_Parameter("Bone"));
 		Commands->Set_Model(newobj, Get_Parameter("Attach_Model"));
 		Commands->Attach_To_Object_Bone(newobj, obj, Get_Parameter("Bone"));
 		newobjID = Commands->Get_ID(newobj);
@@ -3879,6 +3984,7 @@
 ScriptRegistrant<RA_Vehicle_Team_Timer> RA_Vehicle_Team_Timer_Registrant("RA_Vehicle_Team_Timer","");
 ScriptRegistrant<RA_Visible_Driver> RA_Visible_Driver_Registrant("RA_Visible_Driver","BoneName=seat0:string,Message=471174:int");
 ScriptRegistrant<RA_Vision_Control> RA_Vision_Control_Registrant("RA_Vision_Control","FogController=RA_Game_Manager:string");
+ScriptRegistrant<RA_Vision_Control_2> RA_Vision_Control_2_Registrant("RA_Vision_Control_2","FogController=RA_Game_Manager:string,InfantryFogStart=0:float,InfantryFogEnd=9:float,VehicleFogStart=0:float,VehicleFogEnd=9:float");
 ScriptRegistrant<RA_Fog_Level_Settings> RA_Fog_Level_Settings_Registrant("RA_Fog_Level_Settings", "FogEnable=1:int,FogMin=200.0:float,FogMax=300.0:float");
 ScriptRegistrant<RA_Missile_Beacon> RA_Missile_Beacon_Registrant("RA_Missile_Beacon", "SiloPresetName:string");
 ScriptRegistrant<RA_Beacon_Terminal> RA_Beacon_Terminal_Registrant("RA_Beacon_Terminal", "BeaconPowerup:string,BeaconReadySound:string,BeaconTakenSound:string,SiloDisableSound:string,SpyNotifySound:string");
diff -uwr sourceold/scripts/renalert.h source/scripts/renalert.h
--- sourceold/scripts/renalert.h	2011-10-21 21:50:39.739257800 +0800
+++ source/scripts/renalert.h	2012-02-08 08:49:58.555664000 +0800
@@ -337,6 +337,16 @@
 	public: void Register_Auto_Save_Variables();
 };
 
+class RA_Vision_Control_2 : public ScriptImpClass {
+	bool allowed;
+	bool underwater;
+	bool driving;
+	bool blackout;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj, int type, int param, GameObject *sender);
+	public: void Register_Auto_Save_Variables();
+};
+
 class RA_Fog_Level_Settings : public ScriptImpClass {
 	void Custom(GameObject *obj, int type, int param, GameObject *sender);
 };
diff -uwr sourceold/scripts/scripts.vcxproj source/scripts/scripts.vcxproj
--- sourceold/scripts/scripts.vcxproj	2011-11-26 13:18:44.188476500 +0800
+++ source/scripts/scripts.vcxproj	2012-03-06 21:47:37.583984300 +0800
@@ -496,6 +496,7 @@
     <ClCompile Include="tcw_game.cpp" />
     <ClCompile Include="tcw_player.cpp" />
     <ClCompile Include="tcw_powerup.cpp" />
+    <ClCompile Include="tcw_superweapons.cpp" />
     <ClCompile Include="tcw_technology.cpp" />
     <ClCompile Include="tcw_vehicle.cpp" />
     <ClCompile Include="tcw_zone.cpp" />
@@ -510,6 +511,7 @@
     <ClCompile Include="z_cold_fever.cpp" />
     <ClCompile Include="z_coop.cpp" />
     <ClCompile Include="z_darkdawn.cpp" />
+    <ClCompile Include="z_domination.cpp" />
     <ClCompile Include="z_endgame.cpp" />
     <ClCompile Include="z_escort.cpp" />
     <ClCompile Include="z_eveninglight.cpp" />
@@ -766,6 +768,7 @@
     <ClInclude Include="tcw_game.h" />
     <ClInclude Include="tcw_player.h" />
     <ClInclude Include="tcw_powerup.h" />
+    <ClInclude Include="tcw_superweapons.h" />
     <ClInclude Include="tcw_technology.h" />
     <ClInclude Include="tcw_vehicle.h" />
     <ClInclude Include="tcw_zone.h" />
@@ -796,6 +799,7 @@
     <ClInclude Include="z_cold_fever.h" />
     <ClInclude Include="z_coop.h" />
     <ClInclude Include="z_darkdawn.h" />
+    <ClInclude Include="z_domination.h" />
     <ClInclude Include="z_endgame.h" />
     <ClInclude Include="z_escort.h" />
     <ClInclude Include="z_eveninglight.h" />
